﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions; // для работы с регулярными выражениями

namespace kurs
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public StringBuilder logerStr = new StringBuilder();

       public class findStr
        {
            public int nomerStr;  // номер строки
            public String samaStr; // сама строка
            public bool incl; //  включена или выключена
        }

       public List<findStr> strList = new List<findStr>(); // список найденных строк


        //  функция поиска строки по заднному шаблону 
        // с дальнейшим формированием группы
        private void searchReg(string strpat,string group , string nameStr){
            Regex regex = new Regex(strpat);
            MatchCollection matches = regex.Matches(codeBox.Text);
            string text = "";

            foreach (Match matche in matches)
            {
                text += matche.Groups[group].Value + "\r\n";
            }

            logBox.AppendText(nameStr+" \r\n");
            logBox.AppendText(text);
            logBox.AppendText("------------------------------------------------------------\r\n");

            logerStr.Append(nameStr + " \r\n");
            logerStr.Append(text);
            logerStr.Append("------------------------------------------------------------\r\n");
        }

        // поиск фаилов в коде без формирования групп
        private void searchRegFiles(string strpat, string nameStr)
        {
            Regex regex = new Regex(strpat);
            MatchCollection matches = regex.Matches(codeBox.Text);
            string text = "";

            foreach (Match matche in matches)
            {
                text += matche.Value + "\r\n";
            }

            logBox.AppendText(nameStr + " \r\n");
            logBox.AppendText(text);
            logBox.AppendText("------------------------------------------------------------\r\n");

            logerStr.Append(nameStr + " \r\n");
            logerStr.Append(text);
            logerStr.Append("------------------------------------------------------------\r\n");
        }

        // парсинг функции
        private void searchRegF(string strpat, string group, string nameStr)
        {
            Regex regex = new Regex(strpat);
            MatchCollection matches = regex.Matches(codeBox.Text);

            Regex regexParam = new Regex(@"\(.+\)");

            string text = "";
            string[] st, st1;
            logBox.AppendText(nameStr + " \r\n");
            logerStr.Append(nameStr + " \r\n");
            foreach (Match matche in matches)
            {
                text += matche.Value + "\r\n";
                st1 = matche.Value.Split('(');
                st = st1[0].Split(' ');

                Match matchesParam = regexParam.Match(matche.Value);

                string sub = matchesParam.Value.Substring(1, matchesParam.Value.Length-2);

                logBox.AppendText("Имя функции: " + st[2] + " \r\n");
                logBox.AppendText("Модификатор функции: " + st[0] + " \r\n");
                logBox.AppendText("Тип функции: " + st[1] + " \r\n");
                logBox.AppendText("Параметры функции: " + sub + " \r\n");
                logBox.AppendText("\n");

                logerStr.Append("Имя функции: " + st[2] + " \r\n");
                logerStr.Append("Модификатор функции: " + st[0] + " \r\n");
                logerStr.Append("Тип функции: " + st[1] + " \r\n");
                logerStr.Append("Параметры функции: " + sub + " \r\n");
                logerStr.Append("\n");

            }

            logBox.AppendText("------------------------------------------------------------\r\n");
            logerStr.Append("------------------------------------------------------------\r\n");
        }

        // поиск процедуры в коде
        private int searchProcedure(string strpat,  string nameStr)
        {
            Regex regex = new Regex(strpat);
            MatchCollection matches = regex.Matches(nameStr);
            foreach (Match matche in matches)
            {
                return 1;
            }
            return -1;
        }


        private void openFile_Click(object sender, EventArgs e)
        {
            // открытие фаила с  кодом для парсинга
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Filter = "Файлы cs (*.cs)|*.cs";
            if (dlg.ShowDialog() != DialogResult.OK)
                return;
            if (File.Exists(dlg.FileName))
                codeBox.Text = File.ReadAllText(dlg.FileName, Encoding.UTF8);
        }


        private void parseCode_Click(object sender, EventArgs e)
        {
            logBox.Clear();
            // функции поиска 
            // первый параметр - регулярное выражение
            //второй - группы(если есть)
            // название для вывода в лог
            searchReg(@"class\s+(?<class>\w+)","class","КЛАССЫ:");
            searchReg(@"using\s+(?<using>\w+)", "using", "ПРОСТРАНСТВА ИМЕН:");
            searchRegF(@"[a-zA-Z]+\s+\S+\s+[a-zA-Z0-9]+\(.+\)(\s|\n|\r|\t)*\{", "func", "ФУНКЦИИ:");
            searchRegFiles(@".:\\.+\.[A-Za-z]+", "ФАИЛЫ:");
           
        }

        private void fullScr_Click(object sender, EventArgs e)
        {
            Log frm = new Log(this);// открытие формы с логом
            frm.Show();
        }

        private void btnFind_Click(object sender, EventArgs e)
        {
            string[] tempArray = codeBox.Lines;// определение массива строк из текста кода
            strList.Clear(); // чистим список найденных  строк

            for (int counter = 0; counter < tempArray.Length; counter++)
            {
                // поиск строк по 1 условию
                if (subString1.Text != "")
                {
                    int i = tempArray[counter].IndexOf(subString1.Text);
                    if (i != -1)
                    {
                        findStr istr = new findStr();
                        istr.nomerStr = counter;
                        istr.samaStr = tempArray[counter];
                        istr.incl = true;
                        strList.Add(istr);
                    }
                }
                //поиск строк по 2 условию
                if ((subString2.Text != "") && (str2off.Checked == false))
                {
                    int i = tempArray[counter].IndexOf(subString2.Text);
                    if (i != -1)
                    {
                        findStr istr = new findStr();
                        istr.nomerStr = counter;
                        istr.samaStr = tempArray[counter];
                        istr.incl = true;
                        strList.Add(istr);
                    }
                }
                // поиск строк по 3 условию
                if ((subString3.Text != "") && (str3off.Checked == false))
                {
                    int i = tempArray[counter].IndexOf(subString3.Text);
                    if (i != -1)
                    {
                        findStr istr = new findStr();
                        istr.nomerStr = counter;
                        istr.samaStr = tempArray[counter];
                        istr.incl = true;
                        strList.Add(istr);
                    }
                }
                //  поиск строк по содержащих условия
                if ((comb.Text != "") && (comb.Text == "условие"))
                {
                    int i = tempArray[counter].IndexOf("if");
                    if (i != -1)
                    {
                        findStr istr = new findStr();
                        istr.nomerStr = counter;
                        istr.samaStr = tempArray[counter];
                        istr.incl = true;
                        strList.Add(istr);
                    }
                }

                // поиск строк содержащих циклы
                if ((comb.Text != "") && (comb.Text == "цикл"))
                {
                    int i = tempArray[counter].IndexOf("for");
                    if (i != -1)
                    {
                        findStr istr = new findStr();
                        istr.nomerStr = counter;
                        istr.samaStr = tempArray[counter];
                        istr.incl = true;
                        strList.Add(istr);
                    }
                }

                //  поиск строк с объявлением процедур
                if ((comb.Text != "") && (comb.Text == "процедура"))
                {
                    int i = searchProcedure(@"[a-zA-Z]+\s+\w+\s+[a-zA-Z0-9]+\(.+\)", tempArray[counter]);
                   
                    if (i != -1)
                    {
                        findStr istr = new findStr();
                        istr.nomerStr = counter;
                        istr.samaStr = tempArray[counter];
                        istr.incl = true;
                        strList.Add(istr);
                    }
                }
            }
            //исключить поиск строк по 1 условию
            for (int counter = 0; counter < strList.Count; counter++)
            {
                if ((subString1q.Text != "") && (str1offq.Checked == false))
                {
                    int i = strList[counter].samaStr.IndexOf(subString1q.Text);
                    if (i != -1)
                        strList[counter].incl = false;


                }
                //исключить поиск строк по 2 условию
                if ((subString2q.Text != "") && (str2offq.Checked == false))
                {
                    int i = strList[counter].samaStr.IndexOf(subString2q.Text);
                    if (i != -1)
                        strList[counter].incl = false;
                }
            }

            table frm= new table(this); // вывод результата поиска в таблицу
            frm.Show();
        }




    }
}
